<template>
  <drawer
    :showDrawer="this.drawerView"
    :showHeader="true"
    :showFooter="false"
    :showBtnClose="true"
    :size="'40%'"
    :title="'Visualização'"
    :description="'Dados do usuário'"
    @emit-drawer-closed="handleCloseDrawer"
  >
    <table class="table table-sm">
      <tr>
        <td>
          <small class="font-weight-bold">Plano</small>
          <br />
          {{ this.plan.descricao }}
        </td>
      </tr>
      <tr>
        <td>
          <small class="font-weight-bold">Início do Plano</small>
          <br />
          {{ this.plan.data_inicio | filterDateTime }}
        </td>
      </tr>
      <tr>
        <td>
          <small class="font-weight-bold">Fim do Plano</small>
          <br />
          {{ this.plan.data_fim | filterDateTime }}
        </td>
      </tr>
      <tr>
        <td>
          <small class="font-weight-bold">Objetivos Estratégicos(OE)</small>
          <br />
          <div v-if="this.plan.Niveis.length == 0">
            <empty-message
              title="Sem Objetivos Estratégicos"
              description="O seu plano ainda não possui OEs. Cadastre o seu primeiro!"
              classes="text-center"
            ></empty-message>
          </div>
          <a-table
            v-else
            :columns="columns"
            :data-source="this.plan.Niveis"
            :showHeader="false"
            :pagination="false"
            :size="'small'"
            rowKey="id"
            class="mt-2"
            :row-class-name="customRowClass"
            :custom-row="customRow"
          >
            <span slot="action">
              <a-tag color="blue">32 metas</a-tag>
            </span>
          </a-table>
          <div class="input-group mt-2">
            <input type="text" class="form-control" />
            <div class="input-group-append pl-2 d-flex align-items-center">
              <a-button type="primary" shape="circle" icon="plus" />
            </div>
          </div>
        </td>
      </tr>
    </table>

    <div
      :style="{
        position: 'absolute',
        right: 0,
        bottom: 0,
        width: '100%',
        borderTop: '1px solid #e9e9e9',
        padding: '10px 16px',
        background: '#fff',
        textAlign: 'center',
        zIndex: 1,
      }"
    >
      <a-button :style="{ marginRight: '8px' }" @click="handleCloseDrawer"
        >Fechar</a-button
      >
      <a-button type="primary"> <a-icon type="edit" />Editar </a-button>
    </div>

    <a-drawer
      title="Metas"
      width="40%"
      :closable="true"
      :visible="childrenDrawer"
      @close="onChildrenDrawerClose"
    >
      <a-table
        :columns="columnsMeta"
        :data-source="this.metas"
        :showHeader="false"
        :pagination="false"
        :size="'small'"
        rowKey="id"
        class="mt-2"
        :row-class-name="customRowClass"
        :custom-row="customRow"
      >
        <span slot="action">
          <a-tooltip :mouseEnterDelay="0">
            <template slot="title">Editar</template>
            <a-icon type="edit" class="cursor-pointer h5 mb-0" />
          </a-tooltip>
        </span>
      </a-table>
    </a-drawer>
  </drawer>
</template>

<script>
import Drawer from '@/components/generic-components/drawer/drawer'
import EmptyMessage from '@/components/generic-components/empty-message/empty-message'
import '@/filters/generic-filters/filter-datetime'
export default {
  props: ['plan', 'drawerView'],
  components: {
    Drawer,
    EmptyMessage,
  },
  data() {
    return {
      childrenDrawer: false,
      columns: [
        {
          dataIndex: 'descricao',
          title: 'Objetivo Estratégico',
          sortable: true,
          sortDirection: 'desc',
        },
        {
          dataIndex: 'actions',
          title: 'Ações',
          class: 'text-center  font-weight-light',
          scopedSlots: { customRender: 'action' },
        },
      ],
      columnsMeta: [
        {
          dataIndex: 'titulo',
          title: 'Título',
          sortable: true,
          sortDirection: 'desc',
        },
        {
          dataIndex: 'descricao',
          title: 'Descrição',
          sortable: true,
          sortDirection: 'desc',
        },
        {
          dataIndex: 'actions',
          title: 'Ações',
          class: 'text-center  font-weight-light',
          scopedSlots: { customRender: 'action' },
        },
      ],
      metas: [
        {
          codigo: 651,
          titulo: 'meta teste',
          descricao: '<p>asdsadsadsaadadsada</p>',
          unidade_responsavel: 52,
          usuario_responsavel: 17,
          usuario_responsavel_homologacao: 83,
          data_homologacao: '2020-08-07',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 488,
          titulo: 'Meta teste 2 JP **Não alterem, please 🙏🏻**',
          descricao:
            '<p><span style="color: rgb(0, 0, 0);">Lorem Ipsum&nbsp;is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.</span></p>',
          unidade_responsavel: 3,
          usuario_responsavel: 17,
          usuario_responsavel_homologacao: 17,
          data_homologacao: '2020-05-22',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 7,
        },
        {
          codigo: 661,
          titulo: 'meta teste para 1.3.1',
          descricao: '<p>asdadasd</p>',
          unidade_responsavel: 25,
          usuario_responsavel: 78,
          usuario_responsavel_homologacao: 30708,
          data_homologacao: '2020-08-03',
          unidade_medida: 5,
          NivelCodigo: 2,
          CumulatividadeCodigo: 7,
        },
        {
          codigo: 636,
          titulo: 'meta teste responsavel entrega intermediaria',
          descricao: '<p>asdadsdadsd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 17,
          data_homologacao: '2020-07-20',
          unidade_medida: 1,
          NivelCodigo: 2,
          CumulatividadeCodigo: 7,
        },
        {
          codigo: 496,
          titulo: 'novo teste casa decimal',
          descricao: '',
          unidade_responsavel: 2,
          usuario_responsavel: 22,
          usuario_responsavel_homologacao: 22,
          data_homologacao: '2020-05-21',
          unidade_medida: 2,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 500,
          titulo: 'Sem dados',
          descricao: '<p>asd</p>',
          unidade_responsavel: 4,
          usuario_responsavel: 8,
          usuario_responsavel_homologacao: 8,
          data_homologacao: '2020-05-20',
          unidade_medida: 1,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 507,
          titulo: 'teste',
          descricao: '<p>teste</p>',
          unidade_responsavel: 8,
          usuario_responsavel: 25,
          usuario_responsavel_homologacao: 25,
          data_homologacao: '2020-06-16',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 675,
          titulo: 'Teste',
          descricao: '<p>Teste</p>',
          unidade_responsavel: 25,
          usuario_responsavel: 84,
          usuario_responsavel_homologacao: 25,
          data_homologacao: '2020-09-07',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 7,
        },
        {
          codigo: 512,
          titulo: 'teste 2 routes',
          descricao: '<p>adasdsaa</p>',
          unidade_responsavel: 6,
          usuario_responsavel: 17,
          usuario_responsavel_homologacao: 19,
          data_homologacao: '2020-06-16',
          unidade_medida: 6,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 490,
          titulo: 'teste de meta',
          descricao: '',
          unidade_responsavel: 7,
          usuario_responsavel: 23,
          usuario_responsavel_homologacao: 23,
          data_homologacao: '2020-05-20',
          unidade_medida: 3,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 489,
          titulo: 'teste de meta',
          descricao: '',
          unidade_responsavel: 7,
          usuario_responsavel: 6,
          usuario_responsavel_homologacao: 25,
          data_homologacao: '2020-05-20',
          unidade_medida: 3,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 503,
          titulo: 'Teste de Meta para Verificar Previsto como 0',
          descricao: '',
          unidade_responsavel: 2,
          usuario_responsavel: 18,
          usuario_responsavel_homologacao: 25,
          data_homologacao: '2020-06-23',
          unidade_medida: 2,
          NivelCodigo: 2,
          CumulatividadeCodigo: 7,
        },
        {
          codigo: 650,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 639,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 643,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 647,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 648,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 625,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 649,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 641,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 645,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 642,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 646,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 640,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 644,
          titulo: 'teste metavalor nova criacao',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 632,
          titulo: 'teste mixup user profile',
          descricao: '<p>adadsa</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 20,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-30',
          unidade_medida: 1,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 618,
          titulo: 'teste mv q 9',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 620,
          titulo: 'teste mv q 9',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 624,
          titulo: 'teste mv q 9',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 617,
          titulo: 'teste mv q 9',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 621,
          titulo: 'teste mv q 9',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
        {
          codigo: 622,
          titulo: 'teste mv q 9',
          descricao: '<p>asdasd</p>',
          unidade_responsavel: 7,
          usuario_responsavel: 21,
          usuario_responsavel_homologacao: 20,
          data_homologacao: '2020-07-13',
          unidade_medida: 10,
          NivelCodigo: 2,
          CumulatividadeCodigo: 6,
        },
      ],
    }
  },
  methods: {
    handleCloseDrawer() {
      this.$emit('emit-close-drawer', false)
    },
    showChildrenDrawer() {
      this.childrenDrawer = true
    },
    onChildrenDrawerClose() {
      this.childrenDrawer = false
    },
    customRow(record) {
      return {
        on: {
          click: () => {
            this.showChildrenDrawer(record)
          },
        },
      }
    },
    customRowClass() {
      return 'cursor-pointer'
    },
  },
}
</script>
